## ros-kinetic-ecto-pcl 0.4.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ecto_pcl)

# Deal with catkin
find_package(catkin REQUIRED)
find_package(catkin REQUIRED ecto sensor_msgs pcl_conversions)
catkin_package(INCLUDE_DIRS include
               CATKIN_DEPENDS pcl_conversions sensor_msgs
)

# continue with the find_package
find_package(PCL REQUIRED)
# Remove vtkproj4 from PCL_LIBRARIES as bug
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=819741
list(REMOVE_ITEM PCL_LIBRARIES vtkproj4)
include_directories(SYSTEM
                    ${PCL_INCLUDE_DIRS}
)
include_directories(include ${catkin_INCLUDE_DIRS})

find_package(Boost COMPONENTS signals thread)

ecto_sphinx(${CMAKE_CURRENT_SOURCE_DIR}/doc doc)

# install the include directory
install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/ecto_pcl/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
        COMPONENT main
)


add_subdirectory(src)

enable_testing()
add_subdirectory(test)
add_subdirectory(samples)

=== samples/CMakeLists.txt ===
macro(validate_sample pyfile)
  string(REPLACE ";" " " args "${ARGN}")
  add_test(validate_pcl_${pyfile}
    ${CATKIN_ENV} ${CMAKE_CURRENT_SOURCE_DIR}/${pyfile}.py ${args}
    )
endmacro()


macro(data_download PATH_VAR DATA_FILE)
  set(data_base_url http://vault.willowgarage.com/wgdata1/vol1/ecto_data)
  set(${PATH_VAR} ${PROJECT_BINARY_DIR}/data/${DATA_FILE})
  if(NOT EXISTS ${${PATH_VAR}})
    message(STATUS "Data fetch.\n** Downloading:\n** ${data_base_url}/${DATA_FILE}\n** to:\n** ${${PATH_VAR}}")
    file(DOWNLOAD ${data_base_url}/${DATA_FILE} ${${PATH_VAR}})
  endif()
endmacro()

validate_sample(pcd_rw)

macro(desktop_test_sample pyfile)
  string(REPLACE ";" " " args "${ARGN}")
  add_test(desktop_test_pcl_${pyfile}
    ${CATKIN_ENV} ${CMAKE_CURRENT_SOURCE_DIR}/${pyfile}.py ${args}
    )
endmacro()

if(DESKTOP_TEST)
  data_download(CB_PCD cb.pcd)
  data_download(STILL_LIFE still_life.pcd)

  #opens display
  validate_sample(pcd_viewer)

  desktop_test_sample(pcd_rw ${CB_PCD})
  desktop_test_sample(pcd_viewer ${STILL_LIFE})
  desktop_test_sample(colorize_clusters)
  desktop_test_sample(openni_viewer)
  desktop_test_sample(tabletop_segmentation)

if (ROS_TEST)
  validate_sample(ros_sample)
endif()

endif()

=== src/CMakeLists.txt ===
set(ECTO_PCL_FILES
  ecto_pcl.cpp
  features/NormalEstimation.cpp
  features/FPFHEstimation.cpp
  features/PFHEstimation.cpp
  features/VFHEstimation.cpp
  filters/Cropper.cpp
  filters/ExtractIndices.cpp
  filters/PassThrough.cpp
  filters/PassThroughIndices.cpp
  filters/ProjectInliers.cpp
  filters/StatisticalOutlier.cpp
  filters/RadiusOutlier.cpp
  filters/VoxelGrid.cpp
  io/CloudViewer.cpp
#  io/KinectGrabber.cpp
  io/MergeClouds.cpp
  io/NiConverters.cpp
  io/PCDReader.cpp
  io/PCDWriter.cpp
  io/PLYWriter.cpp
  segmentation/ColorizeClusters.cpp
  segmentation/ExtractPolygonalPrismData.cpp
  segmentation/ExtractLargestCluster.cpp
  segmentation/EuclideanClusterExtraction.cpp
  segmentation/SACSegmentation.cpp
  segmentation/SACSegmentationFromNormals.cpp
  surface/ConvexHull.cpp
  surface/MovingLeastSquares.cpp
)

if (${catkin_VERSION} VERSION_GREATER "0.5.28")
add_subdirectory(ros)
else()
  set(ECTO_PCL_FILES ${ECTO_PCL_FILES} io/PCDWriter.cpp)
endif()

ectomodule(ecto_pcl INSTALL ${ECTO_PCL_FILES})

set_source_files_properties(io/CloudViewer.cpp
  PROPERTIES
  COMPILE_FLAGS -Wno-deprecated
  )

link_ecto(ecto_pcl ${PCL_LIBRARIES}
                   ${catkin_LIBRARIES}
)

=== test/CMakeLists.txt ===
if (CATKIN_ENABLE_TESTING)
  catkin_add_nosetests(test_import.py)
endif()

=== src/ros/CMakeLists.txt ===
# create the cells to output messages
include_directories(SYSTEM
                    ${sensor_msgs_INCLUDE_DIRS}
                    ${PCL_INCLUDE_DIRS}
)

ectomodule(ecto_pcl_ros INSTALL
           module.cpp
           pcl_bridge.cpp
)

link_ecto(ecto_pcl_ros ${catkin_LIBRARIES} ${PCL_LIBRARIES})

=== debian/changelog ===
ros-kinetic-ecto-pcl (0.4.5-0xenial) xenial; urgency=high

  * add dependency on proj to fix PCL compilation on kinetic
  * remove useless dependency on ecto_ros
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 23 Apr 2016 22:00:00 -0000

ros-kinetic-ecto-pcl (0.4.4-0xenial) xenial; urgency=high

  * compile on Xenial
  * fix running examples for doc
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 23 Apr 2016 22:00:00 -0000

ros-kinetic-ecto-pcl (0.4.3-0xenial) xenial; urgency=high

  * SACSegmentationFromNormals: support input indices
  * SACSegmentation: support input indices
  * fix SACSegmentation cell
  * ConvexHull: add input indices
  * remove useless dependency
  * clean tests
  * Added new parameter to ExtractIndices
    - Added parameter to keep the filtered cloud organized, i.e.,
    coordinates of 'removed' points are set to 'NaN'
  * add proper test dependency
  * add proper nosetest
  * clean extensions
  * Contributors: Michael Görner, Sven Albrecht, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 31 Aug 2015 22:00:00 -0000

ros-kinetic-ecto-pcl (0.4.2-0xenial) xenial; urgency=high

  * Use the new header with PCL 1.7.0+
  * Always find pcl_conversions
    Should be okay since it's a package dependency.
  * Find pcl_conversions if building against PCL 1.7.0+
    It gets included depending on the PCL version in src/ros/pcl_bridge.cpp
  * fix sample with newer API
  * Contributors: Vincent Rabaud, pgorczak

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 20 Dec 2014 23:00:00 -0000

ros-kinetic-ecto-pcl (0.4.1-0xenial) xenial; urgency=high

  * Merge pull request #34 <https://github.com/plasmodic/ecto_pcl/issues/34> from v4hn/pass-through-indices
    Add PassThrough for index extraction
  * Merge pull request #33 <https://github.com/plasmodic/ecto_pcl/issues/33> from v4hn/euclidean-cluster-extraction-indices
    Allow EuclideanClusterExtraction to work on input indices
  * Add PassThrough for index extraction
    This module behaves similarly to PassThrough with two changes:
    - It also accepts an optional set of input indices of the input cloud
    It's probably not good to add this to PassThrough as well, because it breaks whatever[:] >> passthrough[:]
    - It produces PointIndices of the original cloud instead of a new cloud
  * Allow EuclideanClusterExtraction to work on input indices
    This allows for a pipeline which outputs Clusters as sets of indices
    of the _original_ (organized) input cloud from the depth image camera.
    That way 2d bounding boxes in the input image can be more efficiently computed.
  * Merge pull request #32 <https://github.com/plasmodic/ecto_pcl/issues/32> from v4hn/pcl-cell-return-values
    pcl_cell: don't ignore the return value of the wrapped cell
  * pcl_cell: don't ignore the return value of the wrapped cell
    This makes sure ecto actually stops processing in case on of the cells
    produces an error and returns something else than ecto::OK.
  * Merge pull request #31 <https://github.com/plasmodic/ecto_pcl/issues/31> from v4hn/convex-hull-explicit-dimensionality
    ConvexHull: add parameter to explicitly set dimensionality of the data/hull
  * ConvexHull: add parameter to explicitly set dimensionality of the data/hull
    I had qhull 2012 via pcl 1.7.2 complaining over here that the input is,
    indeed, _not_ three dimensional when computing the hull of a detected table.
    Turned out pcl is always told to reconstruct a 3d-hull.
  * Contributors: Michael Görner, Vincent Rabaud, v4hn

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Tue, 14 Oct 2014 22:00:00 -0000

ros-kinetic-ecto-pcl (0.4.0-0xenial) xenial; urgency=high

  * depend on pcl_conversions which is lighter
  * drop Fuerte support
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 03 Apr 2014 22:00:00 -0000

ros-kinetic-ecto-pcl (0.3.14-0xenial) xenial; urgency=high

  * fix dependencies with PCL

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Wed, 28 Aug 2013 20:12:21 +0200

=== debian/control ===
Source: ros-kinetic-ecto-pcl
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libproj-dev, python-nose, ros-kinetic-catkin, ros-kinetic-ecto, ros-kinetic-pcl-conversions, ros-kinetic-rosunit, ros-kinetic-sensor-msgs
Homepage: http://plasmodic.github.io/ecto_pcl
Standards-Version: 3.9.2

Package: ros-kinetic-ecto-pcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libproj-dev, ros-kinetic-ecto, ros-kinetic-pcl-conversions, ros-kinetic-sensor-msgs
Description: Ecto bindings for common PCL functionality.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-ecto-pcl//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
